# -*- coding: utf-8 -*-
import subprocess
import time
import datetime
import shutil
import os

class KrbManager:


	ISO_PATH={}
	ISO_PATH["client"]="/var/lib/tcos/tftp/modelo-client/casper/client.nfsroot/etc/krb5.keytab"
	ISO_PATH["biblio"]="/var/lib/tcos/tftp/modelo-biblio/casper/biblio.nfsroot/etc/krb5.keytab"
	ISO_PATH["centro"]="/var/lib/tcos/tftp/modelo-centro/casper/centro.nfsroot/etc/krb5.keytab"
	ISO_PATH["desktop"]="/var/lib/tcos/tftp/modelo-desktop/casper/desktop.nfsroot/etc/krb5.keytab"
	ISO_PATH["infantil"]="/var/lib/tcos/tftp/modelo-infantil/casper/infantil.nfsroot/etc/krb5.keytab"
	ISO_PATH["lite"]="/var/lib/tcos/tftp/modelo-lite/casper/lite.nfsroot/etc/krb5.keytab"
	ISO_PATH["music"]="/var/lib/tcos/tftp/modelo-music/casper/music.nfsroot/etc/krb5.keytab"
	ISO_PATH["pime"]="/var/lib/tcos/tftp/modelo-pime/casper/pime.nfsroot/etc/krb5.keytab"
	ISO_PATH["server"]="/var/lib/tcos/tftp/modelo-server/casper/server.nfsroot/etc/krb5.keytab"
	
	KRB_LOG="/var/log/n4d/krb5"
	KEYTAB_FILE="/etc/krb5.keytab"
		
	KEYTABS_TIMEOUT=10

	def __init__(self,llxvar=None):
		
		self.llxvar=llxvar
		self.request_id=1
		self.copying_keytabs=False
		self.last_request=int(time.time())
		
	
	def add_principal(self,uid,password):
		
		user=uid+"@"+self.llxvar["KRB5_REALM"]
		
		p1=subprocess.Popen(["llxcfg-krb5","addprinc",user,password],stdout=subprocess.PIPE)
		out=p1.communicate()
		
	#def add_principal


	def delete_principal(self,uid):
		
		
		user=uid+"@"+self.llxvar["KRB5_REALM"]
		
		p1=subprocess.Popen(["llxcfg-krb5","--force","delprinc",user],stdout=subprocess.PIPE)
		std_out,std_error=p1.communicate()
		
	#def delete_principal
	
	def change_password(self,uid,password):
		
		user=uid+"@"+self.llxvar["KRB5_REALM"]
		
		
		#           llxcfg-krb5 passwd PRINCIPAL [-randkey|PASSWD]
	
		p1=subprocess.Popen(["llxcfg-krb5","passwd",user,password],stdout=subprocess.PIPE)
		out=p1.communicate()
		
		return out
	
		
	#def change_password
	
	def get_keytabs(self,model):
		
		if model!="client" and model!="biblio" and model!="desktop" and model!="center" and model!="music" and model!="lite" and model!="pime" and model!="infantil" and model!="server":
			return False
		
		t=int(time.time())

		request=str(self.request_id)
		self.request_id+=1


		if t-self.last_request < KrbManager.KEYTABS_TIMEOUT:
			f=open(KrbManager.KRB_LOG,"a")
			f.write("["+datetime.datetime.today().strftime("%d/%m/%y %H:%M:%S") + "] [REQUEST ID# " + request +"] " + model + " is requesting keytabs too soon. IGNORED\n")
			f.close()
			return True
		
		
		if not self.copying_keytabs:
			self.copying_keytabs=True
			f=open(KrbManager.KRB_LOG,"a")
			f.write("["+datetime.datetime.today().strftime("%d/%m/%y %H:%M:%S") + "] [REQUEST ID# " + request +"] " + model + " is requesting keytabs. Now copying...\n")
			f.close()
			
			
			
			try:
				prevmask = os.umask(0)
				shutil.copyfile(KrbManager.KEYTAB_FILE, KrbManager.ISO_PATH[model])
				os.chmod(KrbManager.ISO_PATH[model],0600)
				os.umask(prevmask)
				
			except Exception as e:
				self.copying_keytabs=False
				f=open(KrbManager.KRB_LOG,"a")
				f.write("["+datetime.datetime.today().strftime("%d/%m/%y %H:%M:%S") + "] [REQUEST ID# " + request +"] " + model + " FAILED : " + e.__srt__ + "\n")
				f.close()
				return False
			
			
			
			f=open(KrbManager.KRB_LOG,"a")
			f.write("["+datetime.datetime.today().strftime("%d/%m/%y %H:%M:%S") + "] [REQUEST ID# " +request+"] " + model + " COPYING DONE\n")
			f.close()
			
			self.copying_keytabs=False
			self.last_request=int(time.time())
			
		else:
			
			f=open(KrbManager.KRB_LOG,"a")
			f.write("["+datetime.datetime.today().strftime("%d/%m/%y %H:%M:%S") + "] [REQUEST ID# " +request+"] " + model + " is requesting keytabs while another process is already writting it. Now waiting...\n")
			f.close()
			while (self.copying_keytabs):
				time.sleep(1)
				
			f=open(KrbManager.KRB_LOG,"a")
			f.write("["+datetime.datetime.today().strftime("%d/%m/%y %H:%M:%S") + "] [REQUEST ID# " +request+"] " + model + " WAITING DONE\n")
			f.close()
		
		return True

	#def get_keytabs
	
	